org.eclipse.emf.cdo.server.db.mapping

## Interface IMappingStrategy

-     public interface IMappingStrategy

  The mapping strategy acts as a connection between the DBStore and the database management (and OR-mapping) classes. The `DBStore` uses methods of this interface to create and lookup mappings (or mappers, as they could also be named as such) and to get properties and informations about the mappings used. The mapping classes (e.g., instances of IClassMapping and IListMapping) also use this class as a central point of information and as a resource of common functionalities.
  Since:
    2.0
  Author:
    Eike Stepper, Stefan Winkler

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static interface` | `IMappingStrategy.Props` Contains symbolic constants that specifiy valid keys of `mapping strategy properties`.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `PROP_COLUMN_TYPE_MODIFIER` Deprecated. As of 4.4 use `IMappingStrategy.Props.COLUMN_TYPE_MODIFIER`.
    `static String` | `PROP_FORCE_NAMES_WITH_ID` Deprecated. As of 4.4 use `IMappingStrategy.Props.FORCE_NAMES_WITH_ID`.
    `static String` | `PROP_MAX_FIELD_NAME_LENGTH` Deprecated. As of 4.4 use `IMappingStrategy.Props.MAX_FIELD_NAME_LENGTH`.
    `static String` | `PROP_MAX_TABLE_NAME_LENGTH` Deprecated. As of 4.4 use `IMappingStrategy.Props.MAX_TABLE_NAME_LENGTH`.
    `static String` | `PROP_OBJECT_TYPE_CACHE_SIZE` Deprecated. As of 4.4 use `IMappingStrategy.Props.OBJECT_TYPE_CACHE_SIZE`.
    `static String` | `PROP_QUALIFIED_NAMES` Deprecated. As of 4.4 use `IMappingStrategy.Props.QUALIFIED_NAMES`.
    `static String` | `PROP_TABLE_NAME_PREFIX` Deprecated. As of 4.4 use `IMappingStrategy.Props.TABLE_NAME_PREFIX`.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `IListMapping` | `createListMapping(EClass containingClass, EStructuralFeature feature)` Factory for value mappings of multi-valued-attributes.
    `void` | `createMapping(Connection connection, InternalCDOPackageUnit[] packageUnits, OMMonitor monitor)` Create and initialize the mapping infrastructure for the given packages.
    `ITypeMapping` | `createValueMapping(EStructuralFeature feature)` Factory for value mappings of single-valued attributes.
    `IClassMapping` | `getClassMapping(EClass eClass)` Look up an existing class mapping for the given class.
    `Map<EClass,IClassMapping>` | `getClassMappings()` Returns all class mappings of this strategy.
    `Map<EClass,IClassMapping>` | `getClassMappings(boolean createOnDemand)` Returns all class mappings of this strategy.
    `String` | `getFieldName(EStructuralFeature feature)` Create a suitable column name which can be used to map the given element.
    `String` | `getListJoin(String attrTable, String listTable)`
    `Map<String,String>` | `getProperties()` Returns the configuration properties of this mapping strategy.
    `IDBStore` | `getStore()`
    `String` | `getTableName(EClass containingClass, EStructuralFeature feature)` Create a suitable table name which can be used to map the given element.
    `String` | `getTableName(ENamedElement element)` Create a suitable table name which can be used to map the given element.
    `void` | `handleRevisions(IDBStoreAccessor accessor, EClass eClass, CDOBranch branch, long timeStamp, boolean exactTime, CDORevisionHandler handler)` Passes all revisions of the store to the `handler` if all of the following conditions are met: The `eClass` parameter is `null` or equal to `revision.getEClass()`.
    `boolean` | `hasAuditSupport()` Query if this mapping supports audits.
    `boolean` | `hasBranchingSupport()` Query if this mapping supports branches.
    `boolean` | `hasDeltaSupport()` Query if this mapping supports revision deltas.
    `void` | `queryResources(IDBStoreAccessor accessor, IStoreAccessor.QueryResourcesContext context)` Executes a resource query.
    `void` | `queryXRefs(IDBStoreAccessor accessor, IStoreAccessor.QueryXRefsContext context)` Executes a cross reference query.
    `void` | `rawExport(IDBStoreAccessor accessor, CDODataOutput out, int lastReplicatedBranchID, int lastBranchID, long lastReplicatedCommitTime, long lastCommitTime)`
    `void` | `rawImport(IDBStoreAccessor accessor, CDODataInput in, long fromCommitTime, long toCommitTime, OMMonitor monitor)`
    `Set<CDOID>` | `readChangeSet(IDBStoreAccessor accessor, OMMonitor monitor, CDOChangeSetSegment[] segments)` Returns a set of CDOIDs that have at least one revision in any of the passed branches and time ranges.
    `CloseableIterator<CDOID>` | `readObjectIDs(IDBStoreAccessor accessor)` Get an iterator over all instances of objects in the store.
    `CDOClassifierRef` | `readObjectType(IDBStoreAccessor accessor, CDOID id)` Read the type (i.e.
    `void` | `removeMapping(Connection connection, InternalCDOPackageUnit[] packageUnits)` Remove the mapping infrastructure for the given packages.
    `void` | `repairAfterCrash(IDBAdapter dbAdapter, Connection connection)` Return the maximum object id used in the store.
    `void` | `setProperties(Map<String,String> properties)` Set configuration properties for this mapping strategy.
    `void` | `setStore(IDBStore dbStore)` Set the store to which this MappingStrategy instance belongs.

- - ### Field Detail

    - #### PROP_MAX_TABLE_NAME_LENGTH

          @Deprecated
          static final String PROP_MAX_TABLE_NAME_LENGTH

      Deprecated. As of 4.4 use `IMappingStrategy.Props.MAX_TABLE_NAME_LENGTH`.
      Name of the integer property that configures the maximum length for table names. A value of zero indicates the value of the `db adapter` to be used.
      See Also:
        Constant Field Values

    - #### PROP_MAX_FIELD_NAME_LENGTH

          @Deprecated
          static final String PROP_MAX_FIELD_NAME_LENGTH

      Deprecated. As of 4.4 use `IMappingStrategy.Props.MAX_FIELD_NAME_LENGTH`.
      Name of the integer property that configures the maximum length for column names. A value of zero indicates the value of the `db adapter` to be used.
      See Also:
        Constant Field Values

    - #### PROP_TABLE_NAME_PREFIX

          @Deprecated
          static final String PROP_TABLE_NAME_PREFIX

      Deprecated. As of 4.4 use `IMappingStrategy.Props.TABLE_NAME_PREFIX`.
      Name of the String property that specifies a common prefix for table names.
      See Also:
        Constant Field Values

    - #### PROP_QUALIFIED_NAMES

          @Deprecated
          static final String PROP_QUALIFIED_NAMES

      Deprecated. As of 4.4 use `IMappingStrategy.Props.QUALIFIED_NAMES`.
      Name of the boolean property that configures whether the table names are made of simple class names or of qualified class names.
      See Also:
        Constant Field Values

    - #### PROP_FORCE_NAMES_WITH_ID

          @Deprecated
          static final String PROP_FORCE_NAMES_WITH_ID

      Deprecated. As of 4.4 use `IMappingStrategy.Props.FORCE_NAMES_WITH_ID`.
      Name of the boolean property that configures whether table names and column names are always suffixed with the internal DBID or only in cases where generated names violate the naming constraints of the underlying backend.
      See Also:
        Constant Field Values

    - #### PROP_OBJECT_TYPE_CACHE_SIZE

          @Deprecated
          static final String PROP_OBJECT_TYPE_CACHE_SIZE

      Deprecated. As of 4.4 use `IMappingStrategy.Props.OBJECT_TYPE_CACHE_SIZE`.
      Name of the integer property that configures the size of the object type in-memory cache. Possible configuration values are:
      - 0 (zero). Don't use memory caching.
      - >0. Use memory caching with the cache size given.
      Default is a memory cache size of 10,000,000.

      Since:
        4.0
      See Also:
        Constant Field Values

    - #### PROP_COLUMN_TYPE_MODIFIER

          @Deprecated
          static final String PROP_COLUMN_TYPE_MODIFIER

      Deprecated. As of 4.4 use `IMappingStrategy.Props.COLUMN_TYPE_MODIFIER`.
      Name of a String property that specifies the name of a `column type modifier`.
      Since:
        4.2
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getStore

          IDBStore getStore()

      Returns:
        the store, this MappingStrategy instance belongs to.

    - #### setStore

          void setStore(IDBStore dbStore)

      Set the store to which this MappingStrategy instance belongs. Should only be called by the `DBStore`, and only once to initialize the connection between `DBStore` and mapping strategy.
      Parameters:
        `dbStore` - the DBStore instance to which this MappingStrategy instance belongs.

    - #### createValueMapping

          ITypeMapping createValueMapping(EStructuralFeature feature)

      Factory for value mappings of single-valued attributes.
      Parameters:
        `feature` - the feature for which a mapping should be created. It must hold `feature.isMany() == false`.
      Returns:
        the mapping created.

    - #### createListMapping

          IListMapping createListMapping(EClass containingClass,
                                         EStructuralFeature feature)

      Factory for value mappings of multi-valued-attributes.
      Parameters:
        `containingClass` - the class containing the feature.
        `feature` - the feature for which a mapping should be created. It must hold `feature.isMany() == true`.

    - #### getTableName

          String getTableName(ENamedElement element)

      Create a suitable table name which can be used to map the given element. Should only be called by mapping classes.
      Parameters:
        `element` - the element for which the name should be created. It must hold: `element instanceof EClass || element instanceof EPackage`.
      Returns:
        the created table name. It is guaranteed that the table name is compatible with the chosen database.

    - #### getTableName

          String getTableName(EClass containingClass,
                              EStructuralFeature feature)

      Create a suitable table name which can be used to map the given element. Should only be called by mapping classes. Should only be called by mapping classes.
      Parameters:
        `containingClass` - the class containeng the feature.
        `feature` - the feature for which the table name should be created.
      Returns:
        the created table name. It is guaranteed that the table name is compatible with the chosen database.

    - #### getFieldName

          String getFieldName(EStructuralFeature feature)

      Create a suitable column name which can be used to map the given element. Should only be called by mapping classes.
      Parameters:
        `feature` - the feature for which the column name should be created.
      Returns:
        the created column name. It is guaranteed that the name is compatible with the chosen database.

    - #### createMapping

          void createMapping(Connection connection,
                             InternalCDOPackageUnit[] packageUnits,
                             OMMonitor monitor)

      Create and initialize the mapping infrastructure for the given packages. Should be called from the DBStore or the DBStoreAccessor.
      Parameters:
        `connection` - the connection to use.
        `packageUnits` - the packages whose elements should be mapped.
        `monitor` - the monitor to report progress.

    - #### removeMapping

          void removeMapping(Connection connection,
                             InternalCDOPackageUnit[] packageUnits)

      Remove the mapping infrastructure for the given packages. Should be called from the DBStore or the DBStoreAccessor.
      Parameters:
        `connection` - the connection to use.
        `packageUnits` - the packages for which the mappings should be removed
      Since:
        4.0

    - #### getClassMapping

          IClassMapping getClassMapping(EClass eClass)

      Look up an existing class mapping for the given class. Before this method is called, the class mapping must have been initialized by calling `createMapping(Connection, InternalCDOPackageUnit[], OMMonitor)` on its containing package.
      Parameters:
        `eClass` - the class to look up.
      Returns:
        the class mapping.

    - #### getClassMappings

          Map<EClass,IClassMapping> getClassMappings()

      Returns all class mappings of this strategy.
      Since:
        4.0

    - #### getClassMappings

          Map<EClass,IClassMapping> getClassMappings(boolean createOnDemand)

      Returns all class mappings of this strategy.
      Since:
        4.0

    - #### hasDeltaSupport

          boolean hasDeltaSupport()

      Query if this mapping supports revision deltas.
      If this method returns `true`, it is guaranteed that all class mappings returned by `getClassMapping(EClass)` implement `IClassMappingDeltaSupport`.
      Returns:
        `true` if revision deltas are supported, `false` else.

    - #### hasAuditSupport

          boolean hasAuditSupport()

      Query if this mapping supports audits.
      If this method returns `true`, it is guaranteed that all class mappings returned by `getClassMapping(EClass)` implement `IClassMappingAuditSupport`.
      Returns:
        `true` if audits are supported, `false` else.

    - #### hasBranchingSupport

          boolean hasBranchingSupport()

      Query if this mapping supports branches.
      Returns:
        `true` if branches are supported, `false` else.
      Since:
        3.0

    - #### queryResources

          void queryResources(IDBStoreAccessor accessor,
                              IStoreAccessor.QueryResourcesContext context)

      Executes a resource query.
      Parameters:
        `accessor` - the accessor to use.
        `context` - the context from which the query parameters are read and to which the result is written.

    - #### queryXRefs

          void queryXRefs(IDBStoreAccessor accessor,
                          IStoreAccessor.QueryXRefsContext context)

      Executes a cross reference query.
      Parameters:
        `accessor` - the accessor to use.
        `context` - the context from which the query parameters are read and to which the result is written.
      Since:
        3.0

    - #### readObjectType

          CDOClassifierRef readObjectType(IDBStoreAccessor accessor,
                                          CDOID id)

      Read the type (i.e. class) of the object referred to by a given ID.
      Parameters:
        `accessor` - the accessor to use to look up the type.
        `id` - the ID of the object for which the type is to be determined.
      Returns:
        the type of the object.

    - #### readObjectIDs

          CloseableIterator<CDOID> readObjectIDs(IDBStoreAccessor accessor)

      Get an iterator over all instances of objects in the store.
      Parameters:
        `accessor` - the accessor to use.
      Returns:
        the iterator.

    - #### repairAfterCrash

          void repairAfterCrash(IDBAdapter dbAdapter,
                                Connection connection)

      Return the maximum object id used in the store. This is used by the DBStore if a previous crash is discovered during the startup process. Should only be called by the DBStore and only during startup.
      Parameters:
        `dbAdapter` - the dbAdapter to use to access the database
        `connection` - the connection to use to access the database
      Since:
        4.0

    - #### getProperties

          Map<String,String> getProperties()

      Returns the configuration properties of this mapping strategy.
      Since:
        4.0

    - #### setProperties

          void setProperties(Map<String,String> properties)

      Set configuration properties for this mapping strategy. Should only be called by the factory creating the mapping strategy instance.
      Parameters:
        `properties` - the configuration properties to set.

    - #### handleRevisions

          void handleRevisions(IDBStoreAccessor accessor,
                               EClass eClass,
                               CDOBranch branch,
                               long timeStamp,
                               boolean exactTime,
                               CDORevisionHandler handler)

      Passes all revisions of the store to the `handler` if all of the following conditions are met:
      - The `eClass` parameter is `null` or equal to `revision.getEClass()`.
      - The `branch` parameter is `null` or equal to `revision.getBranch()`.
      - The `timeStamp` parameter is `CDOBranchPoint.UNSPECIFIED_DATE` or equal to `revision.getTimeStamp()`.
      Since:
        4.0

    - #### readChangeSet

          Set<CDOID> readChangeSet(IDBStoreAccessor accessor,
                                   OMMonitor monitor,
                                   CDOChangeSetSegment[] segments)

      Returns a set of CDOIDs that have at least one revision in any of the passed branches and time ranges. DetachedCDORevisions must also be considered!
      Since:
        4.0
      See Also:
        `IStoreAccessor.readChangeSet(OMMonitor, CDOChangeSetSegment...)`

    - #### rawExport

          void rawExport(IDBStoreAccessor accessor,
                         CDODataOutput out,
                         int lastReplicatedBranchID,
                         int lastBranchID,
                         long lastReplicatedCommitTime,
                         long lastCommitTime)
                  throws IOException

      Throws:
        `IOException`
      Since:
        3.0

    - #### rawImport

          void rawImport(IDBStoreAccessor accessor,
                         CDODataInput in,
                         long fromCommitTime,
                         long toCommitTime,
                         OMMonitor monitor)
                  throws IOException

      Throws:
        `IOException`
      Since:
        4.0

    - #### getListJoin

          String getListJoin(String attrTable,
                             String listTable)

      Since:
        4.0

Copyright (c) 2014 Eike Stepper (Berlin, Germany) and others.
All rights reserved. This program and the accompanying materials are made available under the terms of the Eclipse Public License v1.0 which accompanies this distribution, and is available at http://www.eclipse.org/legal/epl-v10.html